#include "AtmoCom.h"


CAtmoCom::CAtmoCom() {
  ComportHandle = -1;
}

CAtmoCom::~CAtmoCom() {
  if(ComportHandle!=-1) {
     CloseHandle(ComportHandle);
  }
}

int CAtmoCom::OpenComPort(int portNummer) {
  /* 
     hier evtl. ber CriticalSection mit SendPwmData Synchronisieren - 
     wenn anderer Thread auch auf diese Klasse zugreift? 
  */
  if(portNummer < 1) then return -1; // macht keinen Sinn
  if(ComportHandle != -1) {
     CloseHandle(ComportHandle);
  }

  char comport[10];
  sprintf(comport,"com%d",portNummer);
  
  ComportHandle = CreateFile (comport, GENERIC_WRITE, 0, NULL, OPEN_EXISTING, 0, NULL); 

  DCB dcb; // fr comport-parameter
  dcb.DCBlength = sizeof(DCB);  // Laenge des Blockes MUSS gesetzt sein!
  GetCommState (ComportHandle, &dcb);    // COM-Einstellungen holen und aendern
  dcb.BaudRate  = 38400;        // Baudrate
  dcb.ByteSize  = 8;            // Datenbits
  dcb.Parity    = NOPARITY;     // Paritt
  dcb.StopBits  = ONESTOPBIT;   // Stopbits
  SetCommState (ComportHandle, &dcb);    // COM-Einstellungen speichern
}

int CAtmoCom::SendPwmData(unsigned char numChannels,int &r[],int &g[],int &b[]) {
    /* hier evtl. ber CriticalSection mit SendPwmData Synchronisieren - 
       wenn anderer Thread auch auf diese Klasse zugreift? 
    */
   DWORD bufSize = 4+3+numChannels*3;
   unsigned char *buffer = new unsigned char[bufSize];
   DWORD iBytesWritten;

   buffer[0] = 0xFF;  // Start Byte
   buffer[1] = 0x00;  // Start Kanal 0
   buffer[2] = 0x00;  // Start Kanal 0
   buffer[3] = numChannels; // ? 
   buffer[4] = 0; // R-Summe            
   buffer[5] = 0; // G-Summe           
   buffer[6] = 0; // B-Summe
   int iBuffer = 7;
   for(int i=0;i<numChannels;i++) {
       buffer[iBuffer++] = r[i] & 255; 
       buffer[iBuffer++] = g[i] & 255; 
       buffer[iBuffer++] = b[i] & 255; 
   } 
   
   WriteFile(ComportHandle, buffer, bufSize, &iBytesWritten, NULL); // schicken an COM-Port

   delete buffer[];
   
   return (&iBytesWritten == bufSize) : 0 ? -1;   
}
